"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractMacroOptions = void 0;
var t = __importStar(require("@babel/types"));
var macroOptionsToTypes = {
    webpackChunkName: 'string',
};
function extractMacroOptions(optionsNode) {
    var macroOptions = {};
    Object.entries(macroOptionsToTypes).forEach(function (_a) {
        var macroOptionName = _a[0], macroOptionType = _a[1];
        for (var _i = 0, _b = optionsNode.properties; _i < _b.length; _i++) {
            var property = _b[_i];
            if (!t.isObjectProperty(property) || !(t.isIdentifier(property.key) || t.isStringLiteral(property.key)))
                continue;
            var propertyKey = t.isStringLiteral(property.key) ? property.key.value : property.key.name;
            if (propertyKey !== macroOptionName)
                continue;
            switch (macroOptionType) {
                case 'string':
                    if (!t.isStringLiteral(property.value)) {
                        throw new Error("The ".concat(macroOptionName, " property must be a string literal."));
                    }
                    break;
            }
            // add to macro options and remove from optionsNode
            macroOptions[macroOptionName] = property.value.value;
            optionsNode.properties.splice(optionsNode.properties.indexOf(property), 1);
        }
    });
    return macroOptions;
}
exports.extractMacroOptions = extractMacroOptions;
;
